import 'package:doctor_app_flutter/config/config.dart';
import 'package:doctor_app_flutter/config/size_config.dart';
import 'package:doctor_app_flutter/icons_app/doctor_app_icons.dart';
import 'package:doctor_app_flutter/models/patient/patiant_info_model.dart';
import 'package:doctor_app_flutter/util/date-utils.dart';
import 'package:doctor_app_flutter/util/helpers.dart';
import 'package:doctor_app_flutter/util/translations_delegate_base.dart';
import 'package:doctor_app_flutter/widgets/shared/Text.dart';
import 'package:doctor_app_flutter/widgets/shared/app_texts_widget.dart';
import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:hexcolor/hexcolor.dart';
import 'package:intl/intl.dart';

class PatientCard extends StatelessWidget {
  final PatiantInformtion patientInfo;
  final Function onTap;
  final String patientType;
  final String arrivalType;
  const PatientCard(
      {Key key,
      this.patientInfo,
      this.onTap,
      this.patientType,
      this.arrivalType})
      : super(key: key);
  @override
  Widget build(BuildContext context) {
    return Container(
        width: SizeConfig.screenWidth * 0.9,
        margin: EdgeInsets.all(6),
        padding: EdgeInsets.only(left: 0, right: 5, bottom: 5, top: 5),
        decoration: BoxDecoration(
          borderRadius: BorderRadius.circular(15),
          color: Colors.white,
        ),
        child: Stack(children: [
          Container(
              height: MediaQuery.of(context).size.height * .17,
              width: 5,
              decoration: BoxDecoration(
                borderRadius: BorderRadius.only(
                    topLeft: Radius.circular(10),
                    bottomLeft: Radius.circular(10)),
                color: patientInfo.patientStatusType == 43
                    ? Colors.green[500]
                    : Colors.red[800],
              )),
          Container(
              padding: EdgeInsets.only(left: 10, right: 10, bottom: 10),
              child: InkWell(
                child: Column(
                  children: [
                    SizedBox(
                      height: 10,
                    ),
                    SERVICES_PATIANT2[int.parse(patientType)] ==
                            "patientArrivalList"
                        ? Padding(
                            padding: EdgeInsets.only(left: 12.0),
                            child: Row(
                              mainAxisAlignment: MainAxisAlignment.spaceBetween,
                              children: [
                                patientInfo.patientStatusType == 43
                                    ? AppText(
                                        TranslationBase.of(context).arrivedP,
                                        color: Colors.green,
                                        fontWeight: FontWeight.bold,
                                        fontFamily: 'Poppins',
                                        fontSize: 12,
                                      )
                                    : AppText(
                                        TranslationBase.of(context).notArrived,
                                        color: Colors.red[800],
                                        fontWeight: FontWeight.bold,
                                        fontFamily: 'Poppins',
                                        fontSize: 12,
                                      ),
                                this.arrivalType == '1'
                                    ? AppText(
                                        patientInfo.startTime != null
                                            ? patientInfo.startTime
                                            : '',
                                        fontFamily: 'Poppins',
                                        fontWeight: FontWeight.w600,
                                      )
                                    : AppText(
                                        DateUtils.convertStringToDateFormat(
                                            patientInfo.arrivedOn,
                                            'MM-dd-yyyy HH:mm'),
                                        fontFamily: 'Poppins',
                                        fontWeight: FontWeight.w600,
                                      )
                              ],
                            ))
                        : SizedBox(),
                    Padding(
                        padding: EdgeInsets.only(left: 12.0),
                        child: Row(
                          mainAxisAlignment: MainAxisAlignment.spaceBetween,
                          children: [
                            Row(children: [
                              AppText(
                                (Helpers.capitalize(patientInfo.firstName) +
                                    " " +
                                    Helpers.capitalize(patientInfo.lastName)),
                                fontSize: SizeConfig.textMultiplier * 2,
                                fontWeight: FontWeight.bold,
                                backGroundcolor: Colors.white,
                                fontFamily: 'Poppins',
                              ),
                              patientInfo.gender == 1
                                  ? Icon(
                                      DoctorApp.male_2,
                                      color: Colors.blue,
                                    )
                                  : Icon(
                                      DoctorApp.female_1,
                                      color: Colors.pink,
                                    ),
                            ]),
                            Row(
                              children: [
                                AppText(
                                  patientInfo.nationalityName ??
                                      patientInfo.nationality,
                                  fontWeight: FontWeight.bold,
                                  fontSize: 14,
                                ),
                                patientInfo.nationality != null
                                    ? ClipRRect(
                                        borderRadius:
                                            BorderRadius.circular(20.0),
                                        child: Image.network(
                                          patientInfo.nationalityFlagURL,
                                          height: 25,
                                          width: 30,
                                          errorBuilder: (BuildContext context,
                                              Object exception,
                                              StackTrace stackTrace) {
                                            return Text('No Image');
                                          },
                                        ))
                                    : SizedBox()
                              ],
                            )
                          ],
                        )),
                    Row(children: <Widget>[
                      Column(
                        mainAxisAlignment: MainAxisAlignment.start,
                        children: <Widget>[
                          Padding(
                            padding: EdgeInsets.only(left: 12.0),
                            child: Container(
                              // decoration: BoxDecoration(
                              //   boxShadow: [
                              //   //   BoxShadow(
                              //   //       color: Color.fromRGBO(0, 0, 0, 0.08),
                              //   //       offset: Offset(0.0, 5.0),
                              //   //       blurRadius: 16.0)
                              //   // ],
                              //   // borderRadius: BorderRadius.all(Radius.circular(35.0)),
                              //   // color: Color(0xffCCCCCC),
                              // ),
                              width: 60,
                              height: 60,
                              child: Image.asset(
                                patientInfo.gender == 1
                                    ? 'assets/images/male_avatar.png'
                                    : 'assets/images/female_avatar.png',
                                fit: BoxFit.cover,
                              ),
                            ),
                          ),
                        ],
                      ),
                      SizedBox(
                        width: 10,
                      ),
                      Expanded(
                          child: Column(
                              crossAxisAlignment: CrossAxisAlignment.start,
                              children: [
                            Container(
                              child: RichText(
                                text: new TextSpan(
                                  style: new TextStyle(
                                      fontSize: 2.0 * SizeConfig.textMultiplier,
                                      color: Colors.black),
                                  children: <TextSpan>[
                                    new TextSpan(
                                        text: TranslationBase.of(context)
                                            .fileNumber,
                                        style: TextStyle(
                                            fontSize: 14,
                                            fontFamily: 'Poppins')),
                                    new TextSpan(
                                        text: patientInfo.patientId.toString(),
                                        style: TextStyle(
                                            fontWeight: FontWeight.w700,
                                            fontFamily: 'Poppins',
                                            fontSize: 15)),
                                  ],
                                ),
                              ),
                            ),
                            Container(
                              child: RichText(
                                text: new TextSpan(
                                  style: new TextStyle(
                                    fontSize: 2.0 * SizeConfig.textMultiplier,
                                    color: Colors.black,
                                    fontFamily: 'Poppins',
                                  ),
                                  children: <TextSpan>[
                                    new TextSpan(
                                        text: TranslationBase.of(context).age +
                                            " : ",
                                        style: TextStyle(fontSize: 14)),
                                    new TextSpan(
                                        text:
                                            "${DateUtils.getAgeByBirthday(patientInfo.dateofBirth, context)}",
                                        style: TextStyle(
                                            fontWeight: FontWeight.w700,
                                            fontSize: 15)),
                                  ],
                                ),
                              ),
                            ),
                            if (SERVICES_PATIANT2[int.parse(patientType)] ==
                                "List_MyOutPatient")
                              Container(
                                child: Row(
                                  mainAxisAlignment: MainAxisAlignment.start,
                                  children: <Widget>[
                                    AppText(
                                      TranslationBase.of(context)
                                              .appointmentDate +
                                          " : ",
                                      fontSize: 14,
                                    ),
                                    patientInfo.startTime != null
                                        ? Container(
                                            height: 15,
                                            width: 60,
                                            decoration: BoxDecoration(
                                              borderRadius:
                                                  BorderRadius.circular(25),
                                              color: HexColor("#20A169"),
                                            ),
                                            child: AppText(
                                              patientInfo.startTime,
                                              color: Colors.white,
                                              fontSize: 1.5 *
                                                  SizeConfig.textMultiplier,
                                              textAlign: TextAlign.center,
                                              fontWeight: FontWeight.bold,
                                            ),
                                          )
                                        : SizedBox(),
                                    SizedBox(
                                      width: 3.5,
                                    ),
                                    Container(
                                      child: AppText(
                                        convertDateFormat2(patientInfo
                                            .appointmentDate
                                            .toString()),
                                        fontSize:
                                            1.5 * SizeConfig.textMultiplier,
                                        fontWeight: FontWeight.bold,
                                      ),
                                    ),
                                    SizedBox(
                                      height: 0.5,
                                    )
                                  ],
                                ),
                                margin: EdgeInsets.only(
                                  top: 8,
                                ),
                              )
                          ]))
                    ]),
                  ],
                ),
                onTap: onTap,
              ))
        ]));

    //  ]),
    // TableRow(children: [
    //   SizedBox(
    //     height: 5,
    //   ),
    //   SizedBox(
    //     height: 5,
    //   )
    // ]),
    // TableRow(children: [
    //   Container(
    //     child: RichText(
    //       text: new TextSpan(
    //         style: new TextStyle(
    //             fontSize: 2.0 * SizeConfig.textMultiplier,
    //             color: Colors.black),
    //         children: <TextSpan>[
    //   new TextSpan(
    //       text: TranslationBase.of(context)
    //               .nationality +
    //           " : ",
    //       style: TextStyle(
    //           fontWeight: FontWeight.w700,
    //           fontSize: 2.2 *
    //               SizeConfig.textMultiplier)),
    //         // ,
    //       ],
    //     ),
    //   ),
    // ),
    //   Container(
    //     child: RichText(
    //       text: new TextSpan(
    //         style: new TextStyle(
    //             fontSize: 2.0 * SizeConfig.textMultiplier,
    //             color: Colors.black),
    //         children: <TextSpan>[
    //           new TextSpan(
    //               text:
    //                   TranslationBase.of(context).gender +
    //                       " : ",
    //               style: TextStyle(
    //                 fontWeight: FontWeight.w700,
    //               )),
    //           new TextSpan(
    //               text:
    //                   patientInfo.gender.toString() == '1'
    //                       ? 'Male'
    //                       : 'Female'),
    //         ],
    //       ),
    //     ),
    //   ),
    // ]),
    // ],
    //),

    //   ),

    // Divider(color: Colors.grey)
    //],
    //),
    //],
    //),
    // onTap: onTap,
    // ),
    //);
  }

  convertDateFormat2(String str) {
    String timeConvert;
    const start = "/Date(";
    const end = "+0300)";

    final startIndex = str.indexOf(start);
    final endIndex = str.indexOf(end, startIndex + start.length);

    var date = new DateTime.fromMillisecondsSinceEpoch(
        int.parse(str.substring(startIndex + start.length, endIndex)));
    String newDate = date.year.toString() +
        "/" +
        date.month.toString().padLeft(2, '0') +
        "/" +
        date.day.toString().padLeft(2, '0');

    return newDate.toString();
  }

  isToday(date) {
    DateTime tempDate = new DateFormat("yyyy-MM-dd").parse(date);
    return DateFormat("yyyy-MM-dd").format(tempDate) ==
        DateFormat("yyyy-MM-dd").format(DateTime.now());
  }

  myBoxDecoration() {
    return BoxDecoration(
        border: Border(
          top: BorderSide(
            color: Colors.green,
            width: 5,
          ),
        ),
        borderRadius: BorderRadius.circular(10));
  }
}
